package Controller

import (
	cmap "github.com/orcaman/concurrent-map"
	log "github.com/sirupsen/logrus"
	"src/Common/DateTime"
	"src/Common/Unit"
	"src/Config"
	"src/Model/Sp"
	"strconv"
	"time"
)

type SpChecker struct {
	Config *Config.Config
	queue cmap.ConcurrentMap
}

func (this *SpChecker) Start() {
	this.queue =cmap.New()
	//定时遍历SP，检查SP是否启动
	go func() {
	START:
		s, ok := this.Config.Sys.Get("config_sp_check_seconds")
		if ok {
			this.check()
			n := Unit.Time2Seconds(s.(string))+10
			time.Sleep(time.Duration(n) * time.Second)
		}
		goto START
	}()
}

func (this *SpChecker) check() {
	for _, tmp := range this.Config.Sps.Items() {
		sp := tmp.(map[string]interface{})
		spid:= sp["id"].(string);
		push_type,_:=strconv.Atoi(sp["push_type"].(string)) //0不推送，1推送
		if push_type == 1 {
			if !this.queue.Has(spid) {
				this.queue.Set(spid, "running")
				spModel := new(Sp.SpModel)
				spModel.Config = this.Config
				spModel.Spid = spid
				st, _ := DateTime.Parse("YYYY-MM-DD hh:mm:ss", sp["push_offset"].(string))
				spModel.StartTime = DateTime.Format("YYYYMMDDhhmmss", st)
				go spModel.Start()
			}
		}else{
			log.Infof("this sp do not need to push media , spinfo : %v",sp)
		}
	}
}